=== modified file 'loggerhead/static/javascript/custom.js'
--- loggerhead/static/javascript/custom.js	2008-07-22 00:40:03 +0000
+++ loggerhead/static/javascript/custom.js	2008-08-14 20:31:07 +0000
@@ -4,6 +4,7 @@
 window.addEvent('domready', function() 
 {
     var search_box = $('q');
+    search_box.removeEvents();
     search_box.addEvents(
     {
         keyup: function()
@@ -14,10 +15,10 @@
             }
             else
             {
-	            if (null != global_timeout_id)
-	            {
-	                clearTimeout(global_timeout_id);
-	            }
+                if (null != global_timeout_id)
+                {
+                    clearTimeout(global_timeout_id);
+                }
                     global_timeout_id = setTimeout('$("q").fireEvent("search",$("q").value)',200);
             }
         },
@@ -25,21 +26,25 @@
         search: function(query)
         {
             url = global_path + 'search?query=' + query;
-	
+
             if ($defined(global_search_request))
             {
                 global_search_request.cancel();
             }
-            global_search_request = new Request({'url':url,'method':'get','onComplete':cool_search});
+            global_search_request = new Request({'url':url,'method':'get','onComplete':function(response)
+              {
+                 cool_search(response,query);
+             }});
+
             global_search_request.send('');
-	        var posicion = search_box.getPosition();
-	        var size     = search_box.getSize();
+            var posicion = search_box.getPosition();
+            var size     = search_box.getSize();
 
-	        $('search_terms').setStyle('position','absolute');
-	        $('search_terms').setStyle('left',posicion.x);
-	        $('search_terms').setStyle('top',posicion.y + size.y);
-	        $('search_terms').setStyle('display','block');
-	        $('search_terms').set('html','Loading...');
+            $('search_terms').setStyle('position','absolute');
+            $('search_terms').setStyle('left',posicion.x);
+            $('search_terms').setStyle('top',posicion.y + size.y);
+            $('search_terms').setStyle('display','block');
+            $('search_terms').set('html','Loading...');
 
             new Request({'url':url,'method':'get','onComplete':cool_search}).send('');
 
@@ -48,15 +53,19 @@
     });
 });
 
-function cool_search(response)
+function cool_search(response, query)
 {
 	var posicion = $('q').getPosition();
 	var size     = $('q').getSize();
-	$('search_terms').set('html',response);
-	$('search_terms').setStyle('display','block');
-	$('search_terms').setStyle('position','absolute');
-	$('search_terms').setStyle('left',posicion.x);
-	$('search_terms').setStyle('top',posicion.y + size.y);
+    var current_query = $('q').get('value');
+    if (current_query == query)
+    {
+	    $('search_terms').set('html',response);
+	    $('search_terms').setStyle('display','block');
+	    $('search_terms').setStyle('position','absolute');
+	    $('search_terms').setStyle('left',posicion.x);
+	    $('search_terms').setStyle('top',posicion.y + size.y);
+    }
 }
 
 function hide_search()

